// ==UserScript==
// @name        Apido
// @namespace   http://drupal.org/project/apido
// @description Code sample enhancements for api.drupal.org
// @author      Corey Aufang
// @include     http://api.drupal.org/*
// @match       http://api.drupal.org/*
// @version     0.5
// ==/UserScript==

if (!this.GM_getValue || (this.GM_getValue.toString && this.GM_getValue.toString().indexOf("not supported")>-1)) {
  this.GM_getValue=function (key,def) {
      return localStorage[key] || def;
  };
  this.GM_setValue=function (key,value) {
      return localStorage[key]=value;
  };
  this.GM_deleteValue=function (key) {
      return delete localStorage[key];
  };
}

(function () {
  var callback = function () {
    $(function () {
      var styles = '<style type="text/css">\
        span.apido-matches{\
          background-color:#F88;\
        }\
        span.apido-first-match{\
          background-color:#F00;\
        }\
        span.php-variable,\
        span.php-brace{\
          cursor:pointer;\
        }\
      </style>';
      $(styles).appendTo("html head");
    
      var match = "",
          old_match,
          highlights = ["php-variable"],
          brace_stack = [];
      
      var code = $("pre.php", document);
      
      code.find('code').contents().each(function () {
        if (this.nodeType == 3) {
          // replacing text in textNodes with html http://stackoverflow.com/questions/2561266/prevent-escaping-special-characters-on-textnodejs-html/2561495#2561495
          var pattern= /[{}\[\]()]/;
          var node= this /* Text node you want to replace strings in */;

          while (match= pattern.exec(node.data)) {
              var brace= document.createElement('span');
              brace.className = 'php-brace';
              brace.innerHTML = match;
              
              node= node.splitText(match.index);
              node= node.splitText(match[0].length);
              node.parentNode.replaceChild(brace, node.previousSibling);
          };

        }
      });
      
      code.find('span.php-brace').each(function () {
        if (this.innerHTML.match(/[{\[(]/)) {
          brace_stack.push(this);
        }
        else {
          // @todo need to fix the poping to for only of same type
          var brace_match = brace_stack.pop();
          $(this).data('php-brace-match', brace_match);
          $(brace_match).data('php-brace-match', this);
        }
      });
      
      code.click(function (e) {
        if (e.target.className) {
          match = e.target.className.match(/(php[\w-]*)/im)[1];
          if (highlights.indexOf(match) != -1) {
            $(old_match).removeClass("apido-matches apido-first-match");
            var first_element = $("span." + match, code).filter(function () {
              return this.innerHTML == e.target.innerHTML;
            }).addClass("apido-matches")
            .eq(0).addClass("apido-first-match");
            
            if (e.metaKey) {
              $(window).scrollTop(first_element.offset().top-10);
            }
            
            old_match = first_element.end();
            
          }
          else if (match == 'php-brace') {
            $(old_match).removeClass("apido-matches apido-first-match");
            old_match = [e.target, $(e.target).data('php-brace-match')];
            $(old_match).addClass('apido-matches');
            
            if (e.metaKey) {
              $(window).scrollTop($(old_match[1]).offset().top-10);
            }
          }
          else {
            $(old_match).removeClass("apido-matches apido-first-match");
          }
          
        }
      });
    });
  };
  
  var script = document.createElement("script");
  script.textContent = "(" + callback.toString() + ")();";
  document.body.appendChild(script);
})();

/**
 * Check for new Apido versions.
 * 
 * GM functions can be invoked from GM environment only.
 */
(function () {
  if (typeof GM_xmlhttpRequest != 'function' || typeof window.google != 'undefined') {
    return;
  }
  // default value here should match @version in comments at top
  var version = GM_getValue('version', '0.5');
  var lastChecked = GM_getValue('update.last', 0);
  var now = parseInt(new Date() / 1000, 10);
  // Check every 3 days.
  var interval = 60 * 60 * 24 * 3;
  if (lastChecked - now < -interval) {
    // Whatever happens to this request, remember that we tried.
    GM_setValue('update.last', now);
    GM_xmlhttpRequest({
      method: 'GET',
      url: 'http://drupalcode.org/project/apido.git/blob_plain/HEAD:/apido.user.js',
      onload: function (responseDetails) {
        if (responseDetails.status == 200) {
          var newversion = responseDetails.responseText.match(/@version +([0-9.]+)/i)[1];
          if (newversion == version) {
            return;
          }
          var doUpdate = window.confirm('A new version of Apido is available. Shall we visit the project page to update?');
          if (doUpdate) {
            window.open('http://drupal.org/project/apido', 'apido');
            // Let's just assume that we DID update. ;)
            //GM_setValue('version', newversion);
          }
        }
      }
    });
  }
})();
